{-# LANGUAGE EmptyDataDecls, FlexibleContexts, FlexibleInstances,
  ForeignFunctionInterface, IncoherentInstances,
  MultiParamTypeClasses, OverlappingInstances, TemplateHaskell,
  TypeFamilies, TypeSynonymInstances #-}
module GDAL.GDALDataset.Implementation where
import Data.Monoid
import Data.Word
import Data.Int
import Foreign.C
import Foreign.Ptr
import Language.Haskell.TH
import Language.Haskell.TH.Syntax
import System.IO.Unsafe
import FFICXX.Runtime.Cast
import FFICXX.Runtime.CodeGen.Cxx
import FFICXX.Runtime.TH
import GDAL.GDALDataset.RawType
import GDAL.GDALDataset.FFI
import GDAL.GDALDataset.Interface
import GDAL.GDALDataset.Cast
import GDAL.GDALDataset.RawType
import GDAL.GDALDataset.Cast
import GDAL.GDALDataset.Interface
import GDAL.OGRLayer.RawType
import GDAL.OGRLayer.Cast
import GDAL.OGRLayer.Interface
import GDAL.GDALMajorObject.RawType
import GDAL.GDALMajorObject.Cast
import GDAL.GDALMajorObject.Interface
import STD.Deletable.RawType
import STD.Deletable.Cast
import STD.Deletable.Interface

instance () => IGDALDataset (GDALDataset) where
        getLayer = xform1 c_gdaldataset_getlayer
        getLayerCount = xform0 c_gdaldataset_getlayercount

instance () => IGDALMajorObject (GDALDataset) where

instance () => IDeletable (GDALDataset) where
        delete = xform0 c_gdaldataset_delete
