{-# LANGUAGE ForeignFunctionInterface, InterruptibleFFI #-}
module GDAL.OGRFeature.FFI where
import Data.Word
import Data.Int
import Foreign.C
import Foreign.Ptr
import GDAL.OGRFeature.RawType
import GDAL.OGRFeature.RawType
import GDAL.OGRGeometry.RawType

foreign import ccall interruptible
               "HGDALOGRFeature.h OGRFeature_delete" c_ogrfeature_delete ::
               Ptr RawOGRFeature -> IO ()

foreign import ccall interruptible
               "HGDALOGRFeature.h OGRFeature_oGRFeature_GetFID"
               c_ogrfeature_ogrfeature_getfid :: Ptr RawOGRFeature -> IO CInt

foreign import ccall interruptible
               "HGDALOGRFeature.h OGRFeature_oGRFeature_GetFieldCount"
               c_ogrfeature_ogrfeature_getfieldcount ::
               Ptr RawOGRFeature -> IO CInt

foreign import ccall interruptible
               "HGDALOGRFeature.h OGRFeature_oGRFeature_GetFieldAsInteger"
               c_ogrfeature_ogrfeature_getfieldasinteger ::
               Ptr RawOGRFeature -> CInt -> IO CInt

foreign import ccall interruptible
               "HGDALOGRFeature.h OGRFeature_oGRFeature_GetFieldAsInteger64"
               c_ogrfeature_ogrfeature_getfieldasinteger64 ::
               Ptr RawOGRFeature -> CInt -> IO CInt

foreign import ccall interruptible
               "HGDALOGRFeature.h OGRFeature_oGRFeature_GetFieldAsString"
               c_ogrfeature_ogrfeature_getfieldasstring ::
               Ptr RawOGRFeature -> CInt -> IO CString

foreign import ccall interruptible
               "HGDALOGRFeature.h OGRFeature_oGRFeature_GetGeometryRef"
               c_ogrfeature_ogrfeature_getgeometryref ::
               Ptr RawOGRFeature -> IO (Ptr RawOGRGeometry)
