{-# LANGUAGE ForeignFunctionInterface, InterruptibleFFI #-}
module GDAL.OGRLineString.FFI where
import Data.Word
import Data.Int
import Foreign.C
import Foreign.Ptr
import GDAL.OGRLineString.RawType
import GDAL.OGRLineString.RawType
import GDAL.OGRPointIterator.RawType
import GDAL.OGRGeometry.RawType
import GDAL.OGRPolygon.RawType
import GDAL.OGRMultiPolygon.RawType
import GDAL.OGREnvelope.RawType
import GDAL.OGRPoint.RawType

foreign import ccall interruptible
               "HGDALOGRLineString.h OGRLineString_getNumPoints"
               c_ogrlinestring_getnumpoints :: Ptr RawOGRLineString -> IO CInt

foreign import ccall interruptible
               "HGDALOGRLineString.h OGRLineString_getPointIterator"
               c_ogrlinestring_getpointiterator ::
               Ptr RawOGRLineString -> IO (Ptr RawOGRPointIterator)

foreign import ccall interruptible
               "HGDALOGRLineString.h OGRLineString_getGeometryType"
               c_ogrlinestring_getgeometrytype :: Ptr RawOGRLineString -> IO CUInt

foreign import ccall interruptible
               "HGDALOGRLineString.h OGRLineString_getEnvelope"
               c_ogrlinestring_getenvelope ::
               Ptr RawOGRLineString -> Ptr RawOGREnvelope -> IO ()

foreign import ccall interruptible
               "HGDALOGRLineString.h OGRLineString_Intersects"
               c_ogrlinestring_intersects ::
               Ptr RawOGRLineString -> Ptr RawOGRGeometry -> IO CBool

foreign import ccall interruptible
               "HGDALOGRLineString.h OGRLineString_Equals" c_ogrlinestring_equals
               :: Ptr RawOGRLineString -> Ptr RawOGRGeometry -> IO CBool

foreign import ccall interruptible
               "HGDALOGRLineString.h OGRLineString_Disjoint"
               c_ogrlinestring_disjoint ::
               Ptr RawOGRLineString -> Ptr RawOGRGeometry -> IO CBool

foreign import ccall interruptible
               "HGDALOGRLineString.h OGRLineString_Touches"
               c_ogrlinestring_touches ::
               Ptr RawOGRLineString -> Ptr RawOGRGeometry -> IO CBool

foreign import ccall interruptible
               "HGDALOGRLineString.h OGRLineString_Crosses"
               c_ogrlinestring_crosses ::
               Ptr RawOGRLineString -> Ptr RawOGRGeometry -> IO CBool

foreign import ccall interruptible
               "HGDALOGRLineString.h OGRLineString_Within" c_ogrlinestring_within
               :: Ptr RawOGRLineString -> Ptr RawOGRGeometry -> IO CBool

foreign import ccall interruptible
               "HGDALOGRLineString.h OGRLineString_Contains"
               c_ogrlinestring_contains ::
               Ptr RawOGRLineString -> Ptr RawOGRGeometry -> IO CBool

foreign import ccall interruptible
               "HGDALOGRLineString.h OGRLineString_Overlaps"
               c_ogrlinestring_overlaps ::
               Ptr RawOGRLineString -> Ptr RawOGRGeometry -> IO CBool

foreign import ccall interruptible
               "HGDALOGRLineString.h OGRLineString_Boundary"
               c_ogrlinestring_boundary ::
               Ptr RawOGRLineString -> IO (Ptr RawOGRGeometry)

foreign import ccall interruptible
               "HGDALOGRLineString.h OGRLineString_Distance"
               c_ogrlinestring_distance ::
               Ptr RawOGRLineString -> Ptr RawOGRGeometry -> IO CDouble

foreign import ccall interruptible
               "HGDALOGRLineString.h OGRLineString_ConvexHull"
               c_ogrlinestring_convexhull ::
               Ptr RawOGRLineString -> IO (Ptr RawOGRGeometry)

foreign import ccall interruptible
               "HGDALOGRLineString.h OGRLineString_Buffer" c_ogrlinestring_buffer
               ::
               Ptr RawOGRLineString -> CDouble -> CInt -> IO (Ptr RawOGRGeometry)

foreign import ccall interruptible
               "HGDALOGRLineString.h OGRLineString_Intersection"
               c_ogrlinestring_intersection ::
               Ptr RawOGRLineString ->
                 Ptr RawOGRGeometry -> IO (Ptr RawOGRGeometry)

foreign import ccall interruptible
               "HGDALOGRLineString.h OGRLineString_Union" c_ogrlinestring_union ::
               Ptr RawOGRLineString ->
                 Ptr RawOGRGeometry -> IO (Ptr RawOGRGeometry)

foreign import ccall interruptible
               "HGDALOGRLineString.h OGRLineString_UnionCascaded"
               c_ogrlinestring_unioncascaded ::
               Ptr RawOGRLineString -> IO (Ptr RawOGRGeometry)

foreign import ccall interruptible
               "HGDALOGRLineString.h OGRLineString_Difference"
               c_ogrlinestring_difference ::
               Ptr RawOGRLineString ->
                 Ptr RawOGRGeometry -> IO (Ptr RawOGRGeometry)

foreign import ccall interruptible
               "HGDALOGRLineString.h OGRLineString_SymDifference"
               c_ogrlinestring_symdifference ::
               Ptr RawOGRLineString ->
                 Ptr RawOGRGeometry -> IO (Ptr RawOGRGeometry)

foreign import ccall interruptible
               "HGDALOGRLineString.h OGRLineString_Centroid"
               c_ogrlinestring_centroid ::
               Ptr RawOGRLineString -> Ptr RawOGRPoint -> IO CInt

foreign import ccall interruptible
               "HGDALOGRLineString.h OGRLineString_Simplify"
               c_ogrlinestring_simplify ::
               Ptr RawOGRLineString -> CDouble -> IO (Ptr RawOGRGeometry)

foreign import ccall interruptible
               "HGDALOGRLineString.h OGRLineString_DelaunayTriangulation"
               c_ogrlinestring_delaunaytriangulation ::
               Ptr RawOGRLineString -> CDouble -> CInt -> IO (Ptr RawOGRGeometry)

foreign import ccall interruptible
               "HGDALOGRLineString.h OGRLineString_Polygonize"
               c_ogrlinestring_polygonize ::
               Ptr RawOGRLineString -> IO (Ptr RawOGRGeometry)

foreign import ccall interruptible
               "HGDALOGRLineString.h OGRLineString_Distance3D"
               c_ogrlinestring_distance3d ::
               Ptr RawOGRLineString -> Ptr RawOGRGeometry -> IO CDouble

foreign import ccall interruptible
               "HGDALOGRLineString.h OGRLineString_delete" c_ogrlinestring_delete
               :: Ptr RawOGRLineString -> IO ()
