{-# LANGUAGE ForeignFunctionInterface, InterruptibleFFI #-}
module GDAL.OGRLinearRing.FFI where
import Data.Word
import Data.Int
import Foreign.C
import Foreign.Ptr
import GDAL.OGRLinearRing.RawType
import GDAL.OGRLinearRing.RawType
import GDAL.OGRPointIterator.RawType
import GDAL.OGRGeometry.RawType
import GDAL.OGRPolygon.RawType
import GDAL.OGRMultiPolygon.RawType
import GDAL.OGREnvelope.RawType
import GDAL.OGRPoint.RawType

foreign import ccall interruptible
               "HGDALOGRLinearRing.h OGRLinearRing_getNumPoints"
               c_ogrlinearring_getnumpoints :: Ptr RawOGRLinearRing -> IO CInt

foreign import ccall interruptible
               "HGDALOGRLinearRing.h OGRLinearRing_getPointIterator"
               c_ogrlinearring_getpointiterator ::
               Ptr RawOGRLinearRing -> IO (Ptr RawOGRPointIterator)

foreign import ccall interruptible
               "HGDALOGRLinearRing.h OGRLinearRing_getGeometryType"
               c_ogrlinearring_getgeometrytype :: Ptr RawOGRLinearRing -> IO CUInt

foreign import ccall interruptible
               "HGDALOGRLinearRing.h OGRLinearRing_getEnvelope"
               c_ogrlinearring_getenvelope ::
               Ptr RawOGRLinearRing -> Ptr RawOGREnvelope -> IO ()

foreign import ccall interruptible
               "HGDALOGRLinearRing.h OGRLinearRing_Intersects"
               c_ogrlinearring_intersects ::
               Ptr RawOGRLinearRing -> Ptr RawOGRGeometry -> IO CBool

foreign import ccall interruptible
               "HGDALOGRLinearRing.h OGRLinearRing_Equals" c_ogrlinearring_equals
               :: Ptr RawOGRLinearRing -> Ptr RawOGRGeometry -> IO CBool

foreign import ccall interruptible
               "HGDALOGRLinearRing.h OGRLinearRing_Disjoint"
               c_ogrlinearring_disjoint ::
               Ptr RawOGRLinearRing -> Ptr RawOGRGeometry -> IO CBool

foreign import ccall interruptible
               "HGDALOGRLinearRing.h OGRLinearRing_Touches"
               c_ogrlinearring_touches ::
               Ptr RawOGRLinearRing -> Ptr RawOGRGeometry -> IO CBool

foreign import ccall interruptible
               "HGDALOGRLinearRing.h OGRLinearRing_Crosses"
               c_ogrlinearring_crosses ::
               Ptr RawOGRLinearRing -> Ptr RawOGRGeometry -> IO CBool

foreign import ccall interruptible
               "HGDALOGRLinearRing.h OGRLinearRing_Within" c_ogrlinearring_within
               :: Ptr RawOGRLinearRing -> Ptr RawOGRGeometry -> IO CBool

foreign import ccall interruptible
               "HGDALOGRLinearRing.h OGRLinearRing_Contains"
               c_ogrlinearring_contains ::
               Ptr RawOGRLinearRing -> Ptr RawOGRGeometry -> IO CBool

foreign import ccall interruptible
               "HGDALOGRLinearRing.h OGRLinearRing_Overlaps"
               c_ogrlinearring_overlaps ::
               Ptr RawOGRLinearRing -> Ptr RawOGRGeometry -> IO CBool

foreign import ccall interruptible
               "HGDALOGRLinearRing.h OGRLinearRing_Boundary"
               c_ogrlinearring_boundary ::
               Ptr RawOGRLinearRing -> IO (Ptr RawOGRGeometry)

foreign import ccall interruptible
               "HGDALOGRLinearRing.h OGRLinearRing_Distance"
               c_ogrlinearring_distance ::
               Ptr RawOGRLinearRing -> Ptr RawOGRGeometry -> IO CDouble

foreign import ccall interruptible
               "HGDALOGRLinearRing.h OGRLinearRing_ConvexHull"
               c_ogrlinearring_convexhull ::
               Ptr RawOGRLinearRing -> IO (Ptr RawOGRGeometry)

foreign import ccall interruptible
               "HGDALOGRLinearRing.h OGRLinearRing_Buffer" c_ogrlinearring_buffer
               ::
               Ptr RawOGRLinearRing -> CDouble -> CInt -> IO (Ptr RawOGRGeometry)

foreign import ccall interruptible
               "HGDALOGRLinearRing.h OGRLinearRing_Intersection"
               c_ogrlinearring_intersection ::
               Ptr RawOGRLinearRing ->
                 Ptr RawOGRGeometry -> IO (Ptr RawOGRGeometry)

foreign import ccall interruptible
               "HGDALOGRLinearRing.h OGRLinearRing_Union" c_ogrlinearring_union ::
               Ptr RawOGRLinearRing ->
                 Ptr RawOGRGeometry -> IO (Ptr RawOGRGeometry)

foreign import ccall interruptible
               "HGDALOGRLinearRing.h OGRLinearRing_UnionCascaded"
               c_ogrlinearring_unioncascaded ::
               Ptr RawOGRLinearRing -> IO (Ptr RawOGRGeometry)

foreign import ccall interruptible
               "HGDALOGRLinearRing.h OGRLinearRing_Difference"
               c_ogrlinearring_difference ::
               Ptr RawOGRLinearRing ->
                 Ptr RawOGRGeometry -> IO (Ptr RawOGRGeometry)

foreign import ccall interruptible
               "HGDALOGRLinearRing.h OGRLinearRing_SymDifference"
               c_ogrlinearring_symdifference ::
               Ptr RawOGRLinearRing ->
                 Ptr RawOGRGeometry -> IO (Ptr RawOGRGeometry)

foreign import ccall interruptible
               "HGDALOGRLinearRing.h OGRLinearRing_Centroid"
               c_ogrlinearring_centroid ::
               Ptr RawOGRLinearRing -> Ptr RawOGRPoint -> IO CInt

foreign import ccall interruptible
               "HGDALOGRLinearRing.h OGRLinearRing_Simplify"
               c_ogrlinearring_simplify ::
               Ptr RawOGRLinearRing -> CDouble -> IO (Ptr RawOGRGeometry)

foreign import ccall interruptible
               "HGDALOGRLinearRing.h OGRLinearRing_DelaunayTriangulation"
               c_ogrlinearring_delaunaytriangulation ::
               Ptr RawOGRLinearRing -> CDouble -> CInt -> IO (Ptr RawOGRGeometry)

foreign import ccall interruptible
               "HGDALOGRLinearRing.h OGRLinearRing_Polygonize"
               c_ogrlinearring_polygonize ::
               Ptr RawOGRLinearRing -> IO (Ptr RawOGRGeometry)

foreign import ccall interruptible
               "HGDALOGRLinearRing.h OGRLinearRing_Distance3D"
               c_ogrlinearring_distance3d ::
               Ptr RawOGRLinearRing -> Ptr RawOGRGeometry -> IO CDouble

foreign import ccall interruptible
               "HGDALOGRLinearRing.h OGRLinearRing_delete" c_ogrlinearring_delete
               :: Ptr RawOGRLinearRing -> IO ()
