{-# LANGUAGE EmptyDataDecls, FlexibleContexts, FlexibleInstances,
  ForeignFunctionInterface, IncoherentInstances,
  MultiParamTypeClasses, OverlappingInstances, TemplateHaskell,
  TypeFamilies, TypeSynonymInstances #-}
module GDAL.OGRMultiPolygon.Implementation where
import Data.Monoid
import Data.Word
import Data.Int
import Foreign.C
import Foreign.Ptr
import Language.Haskell.TH
import Language.Haskell.TH.Syntax
import System.IO.Unsafe
import FFICXX.Runtime.Cast
import FFICXX.Runtime.CodeGen.Cxx
import FFICXX.Runtime.TH
import GDAL.OGRMultiPolygon.RawType
import GDAL.OGRMultiPolygon.FFI
import GDAL.OGRMultiPolygon.Interface
import GDAL.OGRMultiPolygon.Cast
import GDAL.OGRMultiPolygon.RawType
import GDAL.OGRMultiPolygon.Cast
import GDAL.OGRMultiPolygon.Interface
import GDAL.OGRPolygon.RawType
import GDAL.OGRPolygon.Cast
import GDAL.OGRPolygon.Interface
import GDAL.OGREnvelope.RawType
import GDAL.OGREnvelope.Cast
import GDAL.OGREnvelope.Interface
import GDAL.OGRPoint.RawType
import GDAL.OGRPoint.Cast
import GDAL.OGRPoint.Interface
import GDAL.OGRMultiSurface.RawType
import GDAL.OGRMultiSurface.Cast
import GDAL.OGRMultiSurface.Interface
import GDAL.OGRGeometryCollection.RawType
import GDAL.OGRGeometryCollection.Cast
import GDAL.OGRGeometryCollection.Interface
import GDAL.OGRGeometry.RawType
import GDAL.OGRGeometry.Cast
import GDAL.OGRGeometry.Interface
import STD.Deletable.RawType
import STD.Deletable.Cast
import STD.Deletable.Interface

instance () => IOGRMultiPolygon (OGRMultiPolygon) where

instance () => IOGRMultiSurface (OGRMultiPolygon) where

instance () => IOGRGeometryCollection (OGRMultiPolygon) where

instance () => IOGRGeometry (OGRMultiPolygon) where
        getGeometryType = xform0 c_ogrmultipolygon_getgeometrytype
        getEnvelope = xform1 c_ogrmultipolygon_getenvelope
        intersects = xform1 c_ogrmultipolygon_intersects
        equals = xform1 c_ogrmultipolygon_equals
        disjoint = xform1 c_ogrmultipolygon_disjoint
        touches = xform1 c_ogrmultipolygon_touches
        crosses = xform1 c_ogrmultipolygon_crosses
        within = xform1 c_ogrmultipolygon_within
        contains = xform1 c_ogrmultipolygon_contains
        overlaps = xform1 c_ogrmultipolygon_overlaps
        boundary = xform0 c_ogrmultipolygon_boundary
        distance = xform1 c_ogrmultipolygon_distance
        convexHull = xform0 c_ogrmultipolygon_convexhull
        buffer = xform2 c_ogrmultipolygon_buffer
        intersection = xform1 c_ogrmultipolygon_intersection
        union = xform1 c_ogrmultipolygon_union
        unionCascaded = xform0 c_ogrmultipolygon_unioncascaded
        difference = xform1 c_ogrmultipolygon_difference
        symDifference = xform1 c_ogrmultipolygon_symdifference
        centroid = xform1 c_ogrmultipolygon_centroid
        simplify = xform1 c_ogrmultipolygon_simplify
        delaunayTriangulation
          = xform2 c_ogrmultipolygon_delaunaytriangulation
        polygonize = xform0 c_ogrmultipolygon_polygonize
        distance3D = xform1 c_ogrmultipolygon_distance3d

instance () => IDeletable (OGRMultiPolygon) where
        delete = xform0 c_ogrmultipolygon_delete
